class GTK_TARGET_ENTRY_LIST

inherit

	MEMORY
		redefine
			dispose
		end

creation

	make
	
feature

	make is
		do
			if ptr /= Void and ptr /= default_pointer then
				dispose
			end
			create list.make(0,-1)
			ptr := c_target_entry_list_create
		ensure
			ptr /= Void and ptr /= default_pointer
		end

	add_to_list(e: GTK_TARGET_ENTRY) is
		require
			e_exists: e /= Void
		do
			list.add_last(e)
			if ptr = default_pointer then
				ptr := c_target_entry_list_create
			end
			ptr := c_target_entry_list_append(ptr, e.ptr)
		ensure
			list_bigger: list.count = old list.count + 1
		end

	list: ARRAY[GTK_TARGET_ENTRY]

	ptr: POINTER

	dispose is
		do
			if ptr /= default_pointer then
				c_target_entry_list_destroy(ptr)
			end
		end

	count: INTEGER is
		do
			Result := list.count
		end

feature {NONE}
	
	c_target_entry_list_create: POINTER is
		external
			"C"
		ensure
			Result /= Void and Result /= default_pointer
		end
	
	c_target_entry_list_append(lp, ep: POINTER): POINTER is
		-- value of lp could be changed, so it is returned as the Result
		external
			"C"
		ensure
			Result /= Void and Result /= default_pointer
		end
	
	c_target_entry_list_destroy(lp: POINTER) is
		external
			"C"
		end

invariant

	ptr_set: ptr /= Void

end -- GTK_TARGET_ENTRY_LIST
